FORMAT: 1A
HOST: https://inventory.dearsystems.com/ExternalApi/v2/
permalinks: true


# Cin7 Core Developer Portal
## API introduction
Cin7 Core Inventory API is part of Cin7 Core Inventory web application at https://inventory.dearsystems.com. 

<b>You will need to:</b>
+ Create an account there before you can use the API. 
+ Trial accounts are also allowed to access the API.

The API URL is https://inventory.dearsystems.com/externalapi/v2/. To call any API endpoint (method) you must append the endpoint name and parameters to the API URL. eg: https://inventory.dearsystems.com/externalapi/v2/me

<i>Note: The API accepts only JSON data format.</i>

Never assume that the API is actually online at any time. Always queue requests to the API so that you can retry the request in the event of a network failure: even if our server is up 24/7 forever, the network will not be. Consider what happens in the case of a network interruption, eg the cable gets cut by road workers yet again. You should always plan to add all requests to a queue so that they can be tried again in the event of any failure.

Full documentation of each endpoint is available on that endpoint's help page. This includes the operations supported and the full list of available fields with:
+ Name
+ Type 
+ Length
+ Required values

Use our API Explorer to see examples of each data object.

Cin7 Core Inventory API is a subset of the functionality available through Cin7 Core Inventory UI - check the API documentation to see if the functionality you require is available in the API.

In the event of errors, the API will return an appropriate HTML status code, and an error message. You will need to read both the status code and the error message to establish the cause. Typical error messages are shown on the API status codes page.


## Connecting to the API
To use the API you will need your Cin7 Core Account ID and API Application key. These can be created on the API setup page inside Cin7 Core Inventory application: https://inventory.dearsystems.com/ExternalAPI.

Each company that you have access to in Cin7 Core Inventory will have a different Cin7 Core Account ID. You can have multiple API Applications created on the same Cin7 Core account. This allows you to link different applications/add-ons to Cin7 Core, since API limits are applied on per API Application basis.

Your Account ID and API Application Key are equivalent to a login and password. They must be kept secret and not shared in any way.

Each request to the API must include these two values sent as HTTP headers:
+ api-auth-accountid - You must send your Account ID in this header.
+ api-auth-applicationkey - You must send API Application Key in this header.


PHP sample:

```PHP

$account_id = 'api-auth-accountid: youraccountid';
$application_key = 'api-auth-applicationkey: applicationkey';
$naked_dear_url = 'https://inventory.dearsystems.com/ExternalApi/v2/SaleList';

$data = array ('Page' => '1', 'Limit' => '100');
$data = http_build_query($data);

$ch = curl_init();
curl_setopt($ch, CURLOPT_URL,$naked_dear_url."?".$data); //GET API CALL
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

$headers = [
"Content-type: application/json",
$account_id,
$application_key
];

curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
$server_output = curl_exec ($ch);
curl_close ($ch);

print $server_output ;


```

## Pagination
<h4>What is Pagination?</h4>

Pagination is the process of dividing content into discrete pages.

The benefit of pagination is that it allows for faster response times to requests against large datasets like Customers, Products and Invoices, thus providing a more responsive and flexible API for your mission-critical applications.

Cin7 Core Inventory API currently uses pagination on the following endpoints:

+ SaleList
+ PurchaseList
+ StockAdjustmentList
+ StockTakeList
+ StockTransferList
+ Product
+ Сategory

All remaining API endpoints do not support pagination.

<h4>Requesting a page</h4>

Pages are requested by adding page parameter to URL: https://inventory.dearsystems.com/ExternalApi/v2/{endpoint}?page={pagenumber}, where {endpoint} and {pagenumber} are placeholders.

For example, if you wanted to retrieve the 3rd page of 100 records from the Products endpoint we would write https://inventory.dearsystems.com/ExternalApi/v2/Product?page=3. 

<h4>Page size</h4>

The default page size is 100 records, but is configurable by adding the desired page size in the URL querystring, https://inventory.dearsystems.com/ExternalApi/v2/{endpoint}?page={pagenumber}&limit={pagesize}.

The minimum page size is 1 and the maximum page size is 1000 records.

If you want to retrieve the 5th page of 200 ProductAvailability records (ie. 1001st to 1500th record) then you would use this URL: https://inventory.dearsystems.com/ExternalApi/v2/Product?page=5&limit=200.

<h4>Pagination info</h4>

In the endpoints that support Pagination additional parameter Total is returned with every API call response to provide information regarding how many records there are overall. Below is an example of this structure in JSON for Products endpoint.

{ "Products":[{...}], "Total":41}

## API Status Codes 
|Status Code|Description|
|:-----|-----------|
|`200 OK`|Operation was successful|
|`204 No Content`|Operation was successful and there is no content to return|
|`400 Bad Request`|The request was not in a correct form, or the posted data failed a validation test. Check the error returned to see what was wrong with the request.|
|`403 Forbidden`|Method authentication failed|
|`404 Not found`|Endpoint does not exist (eg using /Products instead of /Product)|
|`405 Not allowed`|The method used is not allowed (eg PUT, DELETE)|
|`500 Internal Server Error`|The object passed to the API could not be parsed or some unexpected error occurred in Cin7 Core while processing API request|
|`429 Too Many Requests`|You reached 60 calls per minute API limit|

## Date Format
All date fields in Cin7 Core API (including parameters) are in ISO 8601 format and specifying UTC date: yyyy-MM-ddTHH:mm:ss.fff     e.g. 2012-11-14T13:28:33.363

## Previous API version
Previous API version's description is available here: http://support.dearsystems.com/solution/folders/1000134185


# Group Attribute Set

Attribute Set CRUD operations

### Available Fields for Attribute Set
| Property | Type           | Length | Required |Notes       |
|:-------|----------------------|---------|----------|----------|
| `ID`  | Guid           |         | Yes* | Required for PUT and DELETE, Ignored for POST operations |
| `Name`  | String             | 50        | Yes     | Attribute Set name
| `Attribute#Name`  | String             | 50        | Yes* | Attribute Set attribute name. # - int(1-10). Attribute1Name is required for POST, PUT.        |
| `Attribute#Type`  | String         | 50        | Yes* | Attribute Set attribute type. # - int(1-10). Attribute1Type is required for POST, PUT. Available values are `Not used`, `Text`, `Checkbox`, `List`, `Date`, `Numeric`.            |
| `Attribute#Values`  | String          |         | Yes* | Attribute Set attribute values. Delimiter ",". # - int(1-10). Attribute1Values is required for POST, PUT.             |
| `Attributes`  | <a href="#AttributeSetLineModel"><b>[] Attribute Set Line Model</b></a>          |         |       | Array with attributes. Read-only. |

## Attribute Set [/ref/attributeset]

### GET [GET /ref/attributeset?ID={ID}&Page={Page}&Limit={Limit}&Name={Name}]
+ Parameters
    + Page (optional, number) ... Page
        + Default: 1
    + Limit (optional, number) ... Specifies the page size for pagination. Default page size is 100.
        + Default: 100
    + ID (optional, Guid) ... Only return location with the specific ID
    + Name (optional, string) ... Only return locations that start with the specific name

+ Request (application/json)
    + Headers
    
            api-auth-accountid:704ef231-cd93-49c9-a201-26b4b5d0d35b
            api-auth-applicationkey:0342a546-e0c2-0dff-f0be-6a5e17154033

+ Response 200 (application/json)
    + Body
    
    
            {
                "Total": 1,
                "Page": 1,
                "AttributeSetList": [
                    {
                        "ID": "0ba27d98-42ca-4bf6-9b9e-9f71538bd53d",
                        "Name": "Test set",
                        "Attribute1Name": "List attribute name",
                        "Attribute1Type": "List",
                        "Attribute1Values": "Red, Black, Blue, Aqua",
                        "Attribute2Name": "Check box attribute name",
                        "Attribute2Type": "Checkbox",
                        "Attribute2Values": "",
                        "Attribute3Name": "Text attribute name",
                        "Attribute3Type": "Text",
                        "Attribute3Values": "",
                        "Attribute4Name": "",
                        "Attribute4Type": "Not used",
                        "Attribute4Values": "",
                        "Attribute5Name": "",
                        "Attribute5Type": "Not used",
                        "Attribute5Values": "",
                        "Attribute6Name": "",
                        "Attribute6Type": "Not used",
                        "Attribute6Values": "",
                        "Attribute7Name": "",
                        "Attribute7Type": "Not used",
                        "Attribute7Values": "",
                        "Attribute8Name": "",
                        "Attribute8Type": "Not used",
                        "Attribute8Values": "",
                        "Attribute9Name": "",
                        "Attribute9Type": "Not used",
                        "Attribute9Values": "",
                        "Attribute10Name": "",
                        "Attribute10Type": "Not used",
                        "Attribute10Values": "",
                        "Attributes": [
                            {
                                "Name": "List attribute name",
                                "Type": "List",
                                "Values": "Red, Black, Blue, Aqua"
                            },
                            {
                                "Name": "Check box attribute name",
                                "Type": "Checkbox",
                                "Values": ""
                            },
                            {
                                "Name": "Text attribute name",
                                "Type": "Text",
                                "Values": ""
                            },
                            {
                                "Name": "",
                                "Type": "Not used",
                                "Values": ""
                            },
                            {
                                "Name": "",
                                "Type": "Not used",
                                "Values": ""
                            },
                            {
                                "Name": "",
                                "Type": "Not used",
                                "Values": ""
                            },
                            {
                                "Name": "",
                                "Type": "Not used",
                                "Values": ""
                            },
                            {
                                "Name": "",
                                "Type": "Not used",
                                "Values": ""
                            },
                            {
                                "Name": "",
                                "Type": "Not used",
                                "Values": ""
                            },
                            {
                                "Name": "",
                                "Type": "Not used",
                                "Values": ""
                            }
                        ]
                    }
                ]
            }
        

### POST [POST]
+ Request (application/json)
    + Headers
    
            api-auth-accountid:704ef231-cd93-49c9-a201-26b4b5d0d35b
            api-auth-applicationkey:0342a546-e0c2-0dff-f0be-6a5e17154033
    + Body 
    
             {
                "Name": "Test set",
                "Attribute1Name": "List attribute name",
                "Attribute1Type": "List",
                "Attribute1Values": "Red, Black, Blue, Aqua",
                "Attribute2Name": "Check box attribute name",
                "Attribute2Type": "Checkbox",
                "Attribute2Values": "",
                "Attribute3Name": "Text attribute name",
                "Attribute3Type": "Text",
                "Attribute3Values": "",
            }

+ Response 200 (application/json)
    + Body 
    
            {
                "ID": "0ba27d98-42ca-4bf6-9b9e-9f71538bd53d",
                "Name": "Test set",
                "Attribute1Name": "List attribute name",
                "Attribute1Type": "List",
                "Attribute1Values": "Red, Black, Blue, Aqua",
                "Attribute2Name": "Check box attribute name",
                "Attribute2Type": "Checkbox",
                "Attribute2Values": "",
                "Attribute3Name": "Text attribute name",
                "Attribute3Type": "Text",
                "Attribute3Values": "",
                "Attribute4Name": "",
                "Attribute4Type": "Not used",
                "Attribute4Values": "",
                "Attribute5Name": "",
                "Attribute5Type": "Not used",
                "Attribute5Values": "",
                "Attribute6Name": "",
                "Attribute6Type": "Not used",
                "Attribute6Values": "",
                "Attribute7Name": "",
                "Attribute7Type": "Not used",
                "Attribute7Values": "",
                "Attribute8Name": "",
                "Attribute8Type": "Not used",
                "Attribute8Values": "",
                "Attribute9Name": "",
                "Attribute9Type": "Not used",
                "Attribute9Values": "",
                "Attribute10Name": "",
                "Attribute10Type": "Not used",
                "Attribute10Values": "",
                "Attributes": [
                    {
                        "Name": "Color",
                        "Type": "List",
                        "Values": "Red, Black, Blue, Aqua"
                    },
                    {
                        "Name": "Male?",
                        "Type": "Checkbox",
                        "Values": ""
                    },
                    {
                        "Name": "Special wish",
                        "Type": "Text",
                        "Values": ""
                    },
                    {
                        "Name": "",
                        "Type": "Not used",
                        "Values": ""
                    },
                    {
                        "Name": "",
                        "Type": "Not used",
                        "Values": ""
                    },
                    {
                        "Name": "",
                        "Type": "Not used",
                        "Values": ""
                    },
                    {
                        "Name": "",
                        "Type": "Not used",
                        "Values": ""
                    },
                    {
                        "Name": "",
                        "Type": "Not used",
                        "Values": ""
                    },
                    {
                        "Name": "",
                        "Type": "Not used",
                        "Values": ""
                    },
                    {
                        "Name": "",
                        "Type": "Not used",
                        "Values": ""
                    }
                ]
            }

### PUT [PUT]
+ Request (application/json)
    + Headers
    
            api-auth-accountid:704ef231-cd93-49c9-a201-26b4b5d0d35b
            api-auth-applicationkey:0342a546-e0c2-0dff-f0be-6a5e17154033
    + Body 
   
             {
                "ID": "0ba27d98-42ca-4bf6-9b9e-9f71538bd53d",
                "Name": "Test set name",
                "Attribute1Name": "List attribute name",
                "Attribute1Type": "List",
                "Attribute1Values": "Red, Black, Blue, Aqua",
                "Attribute2Name": "Check box attribute name",
                "Attribute2Type": "Checkbox",
                "Attribute2Values": "",
                "Attribute3Name": "Text attribute name",
                "Attribute3Type": "Text",
                "Attribute3Values": "",
                "Attribute4Name": "Additional attribute",
                "Attribute4Type": "Text",
                "Attribute4Values": "",
                "Attribute5Name": "Hidden attribute name",
                "Attribute5Type": "Not used",
                "Attribute5Values": "",
                "Attribute6Name": "Additional attribute name 2",
                "Attribute6Type": "Checkbox",
                "Attribute6Values": "",
            }
        

+ Response 200 (application/json)
    + Body 
            
            {
                "ID": "0ba27d98-42ca-4bf6-9b9e-9f71538bd53d",
                "Name": "Test set name",
                "Attribute1Name": "List attribute name",
                "Attribute1Type": "List",
                "Attribute1Values": "Red, Black, Blue, Aqua",
                "Attribute2Name": "Check box attribute name",
                "Attribute2Type": "Checkbox",
                "Attribute2Values": "",
                "Attribute3Name": "Text attribute name",
                "Attribute3Type": "Text",
                "Attribute3Values": "",
                "Attribute4Name": "Additional attribute",
                "Attribute4Type": "Text",
                "Attribute4Values": "",
                "Attribute5Name": "Hidden attribute name",
                "Attribute5Type": "Not used",
                "Attribute5Values": "",
                "Attribute6Name": "Additional attribute name 2",
                "Attribute6Type": "Checkbox",
                "Attribute6Values": "",
                "Attribute7Name": "",
                "Attribute7Type": "Not used",
                "Attribute7Values": "",
                "Attribute8Name": "",
                "Attribute8Type": "Not used",
                "Attribute8Values": "",
                "Attribute9Name": "",
                "Attribute9Type": "Not used",
                "Attribute9Values": "",
                "Attribute10Name": "",
                "Attribute10Type": "Not used",
                "Attribute10Values": "",
                "Attributes": [
                    {
                        "Name": "Color",
                        "Type": "List",
                        "Values": "Red, Black, Blue, Aqua"
                    },
                    {
                        "Name": "Male?",
                        "Type": "Checkbox",
                        "Values": ""
                    },
                    {
                        "Name": "Special wish",
                        "Type": "Text",
                        "Values": ""
                    },
                    {
                        "Name": "Text attribute name",
                        "Type": "Text",
                        "Values": ""
                    },
                    {
                        "Name": "Hidden attribute name",
                        "Type": "Not used",
                        "Values": ""
                    },
                    {
                        "Name": "Additional attribute name 2",
                        "Type": "Checkbox",
                        "Values": ""
                    },
                    {
                        "Name": "",
                        "Type": "Not used",
                        "Values": ""
                    },
                    {
                        "Name": "",
                        "Type": "Not used",
                        "Values": ""
                    },
                    {
                        "Name": "",
                        "Type": "Not used",
                        "Values": ""
                    },
                    {
                        "Name": "",
                        "Type": "Not used",
                        "Values": ""
                    }
                ]
            }

### DELETE [DELETE /ref/attributeset?ID={ID}]

+ Parameters
    + ID (required, string) ... ID of Location to Delete

+ Request (application/json)
    + Headers
    
            api-auth-accountid:704ef231-cd93-49c9-a201-26b4b5d0d35b
            api-auth-applicationkey:0342a546-e0c2-0dff-f0be-6a5e17154033
+ Response 200 (application/json)
    + Body

            {
                "Success": true
            }


# Group Bank Accounts

Bank Accounts CRUD operations

### Available Fields for Bank Accounts
| Property           | Type     | Length | Required | Notes                 |
|:-------------------|----------|--------|----------|-----------------------|
| `AccountID`        | Guid     |        |          | Unique ID             |
| `Bank`             | String   | 512    |          | Bank name             |
| `AccountName`      | String   | 256    |          | Account name to which the Bank Account is linked |
| `AccountNumber`    | String   | 256    |          | Account number        |
| `AccountCode`      | String   | 50     |          | Account code to which the Bank Account is linked |
| `Currency`         | String   | 3      |          | Currency              |
| `StatementBalance` | Decimal  |        |          | Statement balance     |
| `BalanceInDear`    | Decimal  |        |          | Cin7 Core balance          |
| `InitialBalance`   | String   |        |          | Initial balance       |

## Bank Accounts [/ref/account/bank]

### GET [GET /ref/account/bank?Page={Page}&Limit={Limit}&ID={ID}&Name={Name}&Bank={Bank}]
+ Parameters
    + Page (optional, number) ... Page
        + Default: 1
    + Limit (optional, number) ... Specifies the page size for pagination. Default page size is 100.
        + Default: 100
    + ID (optional, Guid    ) ... Only return accounts with the specific code
    + Name (optional, string) ... Only return accounts that start with the specific name
    + Bank (optional, string) ... Only return accounts with the specific bank

+ Request (application/json)
    + Headers
    
            api-auth-accountid:704ef231-cd93-49c9-a201-26b4b5d0d35b
            api-auth-applicationkey:0342a546-e0c2-0dff-f0be-6a5e17154033

+ Response 200 (application/json)
    + Body
    
            {
                "Total": 3,
                "Page": 1,
                "BankAccountsList": [
                    {
                        "AccountID": "d5b0294d-e931-47d4-a58c-5c9e2d7d3090",
                        "Bank": "Unknown Bank",
                        "AccountName": "EFT bank account",
                        "AccountNumber": "No Number",
                        "AccountCode": "713",
                        "Currency": "AUD",
                        "StatementBalance": 0,
                        "BalanceInDear": 0,
                        "InitialBalance": 0
                    },
                    {
                        "AccountID": "7d236236-02fa-4a03-890e-865ad34ea94c",
                        "Bank": "Unknown Bank",
                        "AccountName": "PayPal account",
                        "AccountNumber": "No Number",
                        "AccountCode": "718",
                        "Currency": "AUD",
                        "StatementBalance": 0,
                        "BalanceInDear": 0,
                        "InitialBalance": 0
                    },
                    {
                        "AccountID": "ba4fbb6c-b31a-4ccb-a95f-d289ab92f7db",
                        "Bank": "Unknown Bank",
                        "AccountName": "Visa debit card",
                        "AccountNumber": "No Number",
                        "AccountCode": "712",
                        "Currency": "AUD",
                        "StatementBalance": 0,
                        "BalanceInDear": 0,
                        "InitialBalance": 0
                    }
                ]
            }


# Group Brand

Brand CRUD operations

### Available Fields for Brand
| Property | Type           | Length | Required |Notes       |
|:-------|----------------------|---------|----------|----------|
| `ID`  | Guid           |         |          |Required for PUT, Ignored for POST operations          |
| `Name`  | String             | 50        | Yes         |Brand name       |

## Brand [/ref/brand]
### GET [GET /ref/brand?Page={Page}&Limit={Limit}&Name={Name}]

+ Parameters
    + Page (optional, number) ... Page
        + Default: 1
    + Limit (optional, number) ... Specifies the page size for pagination. Default page size is 100.
        + Default: 100
    + Name (optional) ... Only return brands that start with the specific name

+ Request (application/json)
    + Headers
    
            api-auth-accountid:704ef231-cd93-49c9-a201-26b4b5d0d35b
            api-auth-applicationkey:0342a546-e0c2-0dff-f0be-6a5e17154033

+ Response 200 (application/json)
    + Body

            {
                "Total": 1,
                "Page": 1,
                "BrandList": [
                    {
                        "ID": "fa528b78-d8a3-4f87-b1ac-9cea985e337d",
                        "Name": "New Brand"
                    }
                ]
            }

### POST [POST]
+ Request (application/json)
    + Headers
    
            api-auth-accountid:704ef231-cd93-49c9-a201-26b4b5d0d35b
            api-auth-applicationkey:0342a546-e0c2-0dff-f0be-6a5e17154033
    + Body 
    
            {
            Name : "Test new brand"
            }
        

+ Response 200 (application/json)
    + Body 
    
            {
                "ID": "ca585936-d523-4c40-980b-fbd0199d61fc",
                "Name": "Test new brand"
            }

### PUT [PUT]
+ Request (application/json)
    + Headers
    
            api-auth-accountid:704ef231-cd93-49c9-a201-26b4b5d0d35b
            api-auth-applicationkey:0342a546-e0c2-0dff-f0be-6a5e17154033
    + Body 
    
            {
                "ID": "ca585936-d523-4c40-980b-fbd0199d61fc",
                "Name": "Test new brand 1"
            }
        

+ Response 200 (application/json)
    + Body 
    
            {
                "ID": "ca585936-d523-4c40-980b-fbd0199d61fc",
                "Name": "Test new brand 1"
            }

### DELETE [DELETE /ref/brand?ID={ID}]

+ Parameters
    + ID (required, string) ... ID of Brand to Delete

+ Request (application/json)
    + Headers
    
            api-auth-accountid:704ef231-cd93-49c9-a201-26b4b5d0d35b
            api-auth-applicationkey:0342a546-e0c2-0dff-f0be-6a5e17154033
+ Response 200 (application/json)
    + Body

            {
                "Success": true
            }


# Group Carrier

Carrier CRUD operations

### Available Fields for Carrier
| Property      | Type      | Length    | Required  | Notes                 |
|:--------------|-----------|-----------|-----------|-----------------------|
| `CarrierID`   | Guid      |           |           | Unique Carrier ID.    |
| `Description` | String    | 256       | Yes       | Name of Carrier.      |

## Carrier [/ref/carrier]
  
### GET [GET /ref/carrier?Page={Page}&Limit={Limit}&CarrierID={CarrierID}&Description={Description}]
+ Parameters
    + Page (optional, number) ... Page
        + Default: 1
    + Limit (optional, number) ... Specifies the page size for pagination. Default page size is 100.
        + Default: 100
    + CarrierID (optional, Guid) ... Only return Carrier with the specific CarrierID
    + Description (optional, string) ... Only return Carriers that start with the specific Description

+ Request (application/json)
    + Headers
    
            api-auth-accountid:704ef231-cd93-49c9-a201-26b4b5d0d35b
            api-auth-applicationkey:0342a546-e0c2-0dff-f0be-6a5e17154033

+ Response 200 (application/json)
    + Body
    
            {
                "Total": 1,
                "Page": 1,
                "CarrierList": [
                    {
                        "CarrierID": "729cd659-c0ca-4a8a-9771-84539cd2e7e8",
                        "Description": "DEFAULT Carrier"
                    }
                ]
            }
           

 
### POST [POST]
+ Request (application/json)
    + Headers
    
            api-auth-accountid:704ef231-cd93-49c9-a201-26b4b5d0d35b
            api-auth-applicationkey:0342a546-e0c2-0dff-f0be-6a5e17154033
            
    + Body 
    
            {
                "Description": "NEW Carrier"
            }

+ Response 200 (application/json)
    + Body 
    
            {
                "Total": 1,
                "Page": 1,
                "CarrierList": [
                    {
                        "CarrierID": "8a5697fa-4c0b-46a5-a5bf-1864cb76623f",
                        "Description": "NEW Carrier"
                    }
                ]
            }
   

### PUT [PUT]
+ Request (application/json)
    + Headers
    
            api-auth-accountid:704ef231-cd93-49c9-a201-26b4b5d0d35b
            api-auth-applicationkey:0342a546-e0c2-0dff-f0be-6a5e17154033
            
    + Body 
   
            {
                "CarrierID": "8a5697fa-4c0b-46a5-a5bf-1864cb76623f",
                "Description": "UPDATED NEW Carrier"
            }
        

+ Response 200 (application/json)
    + Body 
    
            {
                "Total": 1,
                "Page": 1,
                "CarrierList": [
                    {
                        "CarrierID": "8a5697fa-4c0b-46a5-a5bf-1864cb76623f",
                        "Description": "UPDATED NEW Carrier"
                    }
                ]
            }

### DELETE [DELETE /ref/carrier?ID={ID}]

+ Parameters
    + ID (required, Guid) ... ID of Carrier to Delete

+ Request (application/json)
    + Headers
    
            api-auth-accountid:704ef231-cd93-49c9-a201-26b4b5d0d35b
            api-auth-applicationkey:0342a546-e0c2-0dff-f0be-6a5e17154033
            
+ Response 200 (application/json)
    + Body

            {
                "Success": true
            }


# Group Chart of Accounts

Chart of Accounts CRUD operations

### Available Fields for Chart of Accounts
| Property | Type           | Length | Required | Notes          |
|:---------|----------------|--------|----------|----------------|
| `Code`   | String         | 50     | Yes      | Unique code of Account   |
| `Name`   | String         | 256    | Yes      | Account name   |
| `Type`   | String         | 50     | Yes      | Should be one of the following values: `BANK`, `CURRLIAB`, `LIABILITY`, `TERMLIA`, `PAYGLIABILITY`, `SUPERANNUATIONLIABILITY`, `WAGESPAYABLELIABILITY` |
| `Status` | String         | 50     | Yes      | Account status |
| `Description` | String    |        |          | Account description |
| `Class`  | String         |        |          | Should be one of the following values: `ASSET`, `LIABILITY`, `EXPENSE`, `EQUITY`, `REVENUE` |
| `SystemAccount` | String  |        |          | Read-only for PUT. Should be one of the following values: `Accounts receivable`, `Accounts payable`, `Bank revaluations`, `GST / VAT`, `GST on imports`, `Historical adjustment`, `Realized currency gains`, `Retained earnings`, `Rounding`, `Tracking transfers`, `Unpaid expense claims`, `Unrealized currency gains`, `Wages payable`". For POST requests, the user may optionally provide a value for either SystemAccount or SystemAccountCode. If both fields are provided, the account code and name must correspond to the same account. |
| `SystemAccountCode` | String  |        |          | Read-only for PUT. Should be one of the following values: `BANKCURRENCYGAIN`, `CREDITORS`, `DEBTORS`, `GST`, `GSTONIMPORTS`, `HISTORICAL`, `REALISEDCURRENCYGAIN`, `RETAINEDEARNINGS`, `ROUNDING`, `TRACKINGTRANSFERS`, `UNPAIDEXPCLM`, `UNREALISEDCURRENCYGAIN`, `WAGEPAYABLES`". For POST requests, the user may optionally provide a value for either SystemAccount or SystemAccountCode. If both fields are provided, the account code and name must correspond to the same account. |
| `ForPayments` | String    |        |          | Account status |
| `DisplayName` | String    |        |          | Account display name. Read-only. |
| `OldCode`     | String    |        |          | Read-only.     |
| `Bank`        | String    |        |          | Name of the Bank. Only for PUT and POST. Required if Account `Type` is `BANK`. |
| `BankAccountNumber` | String |     |          | Bank Account Number. Only for PUT and POST. Required if Account `Type` is `BANK`. |
| `BankAccountId` | Guid    |        |          | Bank Account ID to which the Account is linked. Read-only  |
| `Currency`     | String   |        |          | Currency. Read-only.     |


## Chart of Accounts [/ref/account]

### GET [GET /ref/account?Page={Page}&Limit={Limit}&Code={Code}&Name={Name}&Type={Type}&Status={Status}]
+ Parameters
    + Page (optional, number) ... Page
        + Default: 1
    + Limit (optional, number) ... Specifies the page size for pagination. Default page size is 100.
        + Default: 100
    + Code (optional, string) ... Only return accounts with the specific code
    + Name (optional, string) ... Only return accounts that start with the specific name
    + Type (optional, string) ... Only return accounts with the specific type
    + Status (optional, string) ... Only return accounts with the specific status

+ Request (application/json)
    + Headers
    
            api-auth-accountid:704ef231-cd93-49c9-a201-26b4b5d0d35b
            api-auth-applicationkey:0342a546-e0c2-0dff-f0be-6a5e17154033

+ Response 200 (application/json)
    + Body
    
            {
                "Total": 3,
                "Page": 1,
                "AccountsList": [
                    {
                        "Code": "800",
                        "Status": "ACTIVE",
                        "Name": "Accounts Payable",
                        "Type": "CURRLIAB",
                        "Description": "Outstanding invoices the company has received from suppliers but has not yet paid at balance date",
                        "Class": "LIABILITY",
                        "SystemAccount": "Accounts payable",
                        "SystemAccountCode": "CREDITORS",
                        "BankAccountNumber": null,
                        "BankAccountId": null,
                        "ForPayments": false,
                        "DisplayName": "800: Accounts Payable",
                        "OldCode": null
                    },
                    {
                        "Code": "610",
                        "Status": "ACTIVE",
                        "Name": "Accounts Receivable",
                        "Type": "CURRENT",
                        "Description": "Outstanding invoices the company has issued out to the client but has not yet received in cash at balance date.",
                        "Class": "ASSET",
                        "SystemAccount": "Accounts receivable",
                        "SystemAccountCode": "DEBTORS",
                        "BankAccountNumber": null,
                        "BankAccountId": null,
                        "ForPayments": false,
                        "DisplayName": "610: Accounts Receivable",
                        "OldCode": null
                    },
                    {
                        "Code": "400",
                        "Status": "ACTIVE",
                        "Name": "Advertising",
                        "Type": "EXPENSE",
                        "Description": "Expenses incurred for advertising while trying to increase sales",
                        "Class": "EXPENSE",
                        "SystemAccount": null,
                        "SystemAccountCode": null,
                        "BankAccountNumber": null,
                        "BankAccountId": null,
                        "ForPayments": false,
                        "DisplayName": "400: Advertising",
                        "OldCode": null
                    }
                ]
            }


### POST [POST]
+ Request (application/json)
    + Headers
    
            api-auth-accountid:704ef231-cd93-49c9-a201-26b4b5d0d35b
            api-auth-applicationkey:0342a546-e0c2-0dff-f0be-6a5e17154033
    + Body 
    
            {
                "Code": "001",
                "Status": "ACTIVE",
                "Name": "Accounts Payable test",
                "Type": "CURRLIAB",
                "Description": "Outstanding invoices the company has received from suppliers but has not yet paid at balance date",
                "Class": "LIABILITY",
                "SystemAccount": "Accounts payable",
                "SystemAccountCode": "CREDITORS"
            }

+ Response 200 (application/json)
    + Body 
    
            {
                "Total": 1,
                "Page": 1,
                "AccountsList": [
                    {
                        "Code": "001",
                        "Status": "ACTIVE",
                        "Name": "Accounts Payable test",
                        "Type": "CURRLIAB",
                        "Description": "Outstanding invoices the company has received from suppliers but has not yet paid at balance date",
                        "Class": "LIABILITY",
                        "SystemAccount": "Accounts payable",
                        "SystemAccountCode": "CREDITORS",
                        "BankAccountNumber": null,
                        "BankAccountId": null,
                        "ForPayments": false,
                        "DisplayName": "001: Accounts Payable test",
                        "OldCode": null
                    }
                ]
            }

### PUT [PUT]
+ Updating accounts is not allowed while integration with Xero or Quickbooks enabled.
+ Request (application/json)
    + Headers
    
            api-auth-accountid:704ef231-cd93-49c9-a201-26b4b5d0d35b
            api-auth-applicationkey:0342a546-e0c2-0dff-f0be-6a5e17154033
    + Body 
   
            {
                "Code": "001",
                "Status": "ACTIVE",
                "Name": "Accounts Payable put test",
                "Type": "CURRLIAB",
                "Description": "Put test description",
                "Class": "LIABILITY"
            }
        

+ Response 200 (application/json)
    + Body 
            
            {
                "Total": 1,
                "Page": 1,
                "AccountsList": [
                    {
                        "Code": "001",
                        "Status": "ACTIVE",
                        "Name": "Accounts Payable put test",
                        "Type": "CURRLIAB",
                        "Description": "Put test description",
                        "Class": "LIABILITY",
                        "SystemAccount": "Accounts payable",
                        "SystemAccountCode": "CREDITORS",
                        "BankAccountNumber": null,
                        "BankAccountId": null,
                        "ForPayments": false,
                        "DisplayName": "001: Accounts Payable put test",
                        "OldCode": null
                    }
                ]
            }

### DELETE [DELETE /ref/account?Code={Code}]

+ Parameters
    + Code (required, string) ... Code of account to Delete

+ Request (application/json)
    + Headers
    
            api-auth-accountid:704ef231-cd93-49c9-a201-26b4b5d0d35b
            api-auth-applicationkey:0342a546-e0c2-0dff-f0be-6a5e17154033
+ Response 200 (application/json)
    + Body

            {
                "Success": true
            }

# Group Customer

Customer CRUD operations

### Available Fields for Customer
| Property              | Type      | Length    | Required  | Notes                                                         |
|:----------------------|-----------|-----------|-----------|---------------------------------------------------------------|
| `ID`                  | Guid      |           | Yes       | Unique Customer ID.                                           |
| `Name`                | String    | 256       | Yes       | Customer name. Must be unique.                                             |
| `DisplayName`         | String    | 256       |           | Preferred customer name. Unlike `Name`, multiple customers can use this `DisplayName`. It does not need to be unique.                                             |
| `Status`              | String    |           | Yes*      | Points that Customer is Active. Available values are `Active` and `Deprecated`. Required for POST|
| `Currency`            | String    |           | Yes       | Currency code of Customer.                                    |
| `PaymentTerm`         | String    |           | Yes       | Payment term.                                                 |
| `AccountReceivable`   | String    |           | Yes       | Account receivable code of Customer.                          |
| `RevenueAccount`      | String    |           | Yes       | Sale account code of Customer.                                |
| `TaxRule`             | String    |           | Yes       | Tax rule name.                                                |
| `PriceTier`           | String    |           |           | Price tier.                                                   |
| `Carrier`             | String    |           |           | Carrier name.                                                 |
| `SalesRepresentative` | String    |           |           | Sales representative.                                         |
| `Location`            | String    |           |           | Location.                                                     |
| `Discount`            | Int       |           |           | Discount must be between 0% and 100%.                         |
| `Comments`            | String    | 2000       |           | Comments.                                                     |
| `TaxNumber`           | Int       |           |           | Tax number.                                                   |
| `CreditLimit`         | Int       |           |           | Credit limit.                                                 |
| `Tags`                | String    |           |           | Tags string.                                                  |
| `AttributeSet`        | String    |           |           | AttributeSet name.                                            |
| `AdditionalAttribute#`| String    |           |           | Additional attribute value. # - int(1-10).                    |
| `LastModifiedOn`      | String    |           |           | Date of last modification.                                    |
| `IsOnCreditHold`      | Bool      |           |           | Is On Credit Hold.                                    |
| `LastModifiedOn`      | DateTime      |           |           | Date of last modification. UTC Time. Read-only. |
| `IsLegalEntity`      | Bool      |           |           | `true` if a customer is a Legal Entity. Default `false`.  |
| `CustomerParentID`      | Guid      |           |           | The unique Customer ID for a parent customer or `null`.  |
| `CustomerParentName`      | String      | 256          |           | Name of the parent customer.   |
| `IsBillParent`      | Bool      |           |           | Default `false`. Not available if the Parent is empty or null. If `true`, Child uses the Parent's billing address and sales history.  |
| `ProductPrices`       |<a href="#ProductPriceModel"><b>[] Product Price Model</b></a>||| Customer specific Product Prices.         |
| `Addresses`           |<a href="#SupplierAddressModel"><b>[] Customer Address Model</b></a>||| List of addresses.         |
| `Contacts`            |<a href="#SupplierContactModel"><b>[] Customer Contact Model</b></a>||| List of contacts.          |
| `ChildCustomers`            |<a href="#ChildCustomerModel"><b>[] Child Customer Model</b></a>||| Customers’s child records (available only in the responses)       |

## Customer [/customer]  
  
### GET [GET /customer?Page={Page}&Limit={Limit}&ID={ID}&Name={Name}&ModifiedSince={ModifiedSince}&IncludeDeprecated={IncludeDeprecated}&IncludeProductPrices={IncludeProductPrices}&ContactFilter={ContactFilter}]
+ Parameters
    + Page (optional, number) ... Page
        + Default: 1
    + Limit (optional, number) ... Specifies the page size for pagination. Default page size is 100.
        + Default: 100
    + ID (optional, Guid) ... Only return Customer with the specific ID
        + Default: null
    + Name (optional, string) ... Only return Customers which name starts with the specific name
        + Default: null
    + ContactFilter (optional, string) ... Only return Customers which contact name starts with the specified value of contact email equals to specified value
        + Default: null
    + ModifiedSince (optional, DateTime?) ... Only return Customers modified since specified date (UTC time) in ISO 8601 format.
        + Default: null
    + IncludeDeprecated (optional, bool) ... Returns all Customers, including deprecated, if set to true. If set to false or if it is not specified then returns only active (ie. non-deprecated) Suppliers"
        + Default: false
    + IncludeProductPrices (optional, bool) ... Returns all Customers, including customer specific product prices, if set to true. If set to false or if it is not specified then no Product Prices will be returned."
        + Default: false
    

+ Request (application/json)
    + Headers
    
            api-auth-accountid:704ef231-cd93-49c9-a201-26b4b5d0d35b
            api-auth-applicationkey:0342a546-e0c2-0dff-f0be-6a5e17154033

+ Response 200 (application/json)
    + Body
    
            {
                "Total": 2,
                "Page": 1,
                "CustomerList": [
                   {
                        "ID": "0365e5bb-e5ea-4a45-b98b-fdc4466bdaf1",
                        "Name": "Human Test",
                        "DisplayName": "Mary Jane",
                        "Currency": "AUD",
                        "PaymentTerm": "30 days",
                        "Discount": 0,
                        "TaxRule": "BAS Excluded",
                        "Carrier": "DEFAULT Carrier",
                        "SalesRepresentative": null,
                        "Location": "Main Warehouse",
                        "Comments": "",
                        "AccountReceivable": "610",
                        "RevenueAccount": "200",
                        "PriceTier": "Tier 1",
                        "TaxNumber": "",
                        "AdditionalAttribute1": "",
                        "AdditionalAttribute2": "",
                        "AdditionalAttribute3": "",
                        "AdditionalAttribute4": "",
                        "AdditionalAttribute5": "",
                        "AdditionalAttribute6": "",
                        "AdditionalAttribute7": "",
                        "AdditionalAttribute8": "",
                        "AdditionalAttribute9": "",
                        "AdditionalAttribute10": "",
                        "AttributeSet": null,
                        "Tags": "",
                        "Status": "Active",
                        "CreditLimit": 0,
                        "IsOnCreditHold": false,
                        "IsLegalEntity": false,
                        "CustomerParentID": null,
                        "CustomerParentName": null,
                        "IsBillParent": false,
                        "LastModifiedOn": "2018-01-24T05:07:23.917Z",
                        "Addresses": [
                            {
                                "Line1": "P O Box 456",
                                "Line2": "Southbank",
                                "City": "Melbourne GPO",
                                "State": "VIC",
                                "Postcode": "3331",
                                "Country": "Uruguay",
                                "Type": "Billing",
                                "DefaultForType": true,
                                "ID": "fc8ca28e-7f91-4ac3-8fff-deb86395b494"
                            }
                        ],
                        "Contacts": [
                            {
                                "Name": "Nick Wakefield",
                                "JobTitle": null,
                                "Phone": "03 3014556",
                                "MobilePhone": null,
                                "Fax": null,
                                "Email": null,
                                "Website": null,
                                "Default": true,
                                "Comment": null,
                                "IncludeInEmail": false,
                                "MarketingConsent": 1,
                                "ID": "c650db26-2fca-4fe4-837d-ffd0f4d97200"
                            }
                        ],
                        "ChildCustomers": [
                            {
                                "CustomerID": "4f36c2a6-f736-450f-be41-28372bde80f6",
                                "CustomerName": "Child Customer"
                            }
                        ]
                    },
                    {
                        "ID": "861918cc-81f9-4701-9639-864c796561cf",
                        "Name": "Customer Test",
                        "DisplayName": "John Doe",
                        "Currency": "AUD",
                        "PaymentTerm": "30 days",
                        "Discount": 0,
                        "TaxRule": "GST Free Exports",
                        "Carrier": null,
                        "SalesRepresentative": null,
                        "Location": "Main Warehouse",
                        "Comments": null,
                        "AccountReceivable": "610",
                        "RevenueAccount": "200",
                        "PriceTier": "Tier 1",
                        "TaxNumber": null,
                        "AdditionalAttribute1": null,
                        "AdditionalAttribute2": null,
                        "AdditionalAttribute3": null,
                        "AdditionalAttribute4": null,
                        "AdditionalAttribute5": null,
                        "AdditionalAttribute6": null,
                        "AdditionalAttribute7": null,
                        "AdditionalAttribute8": null,
                        "AdditionalAttribute9": null,
                        "AdditionalAttribute10": null,
                        "AttributeSet": null,
                        "Tags": null,
                        "Status": "Active",
                        "CreditLimit": 0,
                        "IsOnCreditHold": false,
                        "IsLegalEntity": true,
                        "CustomerParentID": "ceb4ef7a-e23d-4730-8021-e807e5b76882",
                        "CustomerParentName": "Parent customer test",
                        "IsBillParent":true,
                        "LastModifiedOn": "2018-01-30T06:07:43.46Z",
                        "Addresses": [],
                        "Contacts": [
                            {
                                "Name": "Customer Test",
                                "JobTitle": null,
                                "Phone": null,
                                "MobilePhone": null,
                                "Fax": null,
                                "Email": "Customer@mail.ru",
                                "Website": null,
                                "Default": true,
                                "Comment": null,
                                "IncludeInEmail": false,
                                "MarketingConsent": 2,
                                "ID": "23ef723b-75b5-43b3-8ee7-56d193e53923"
                            }
                        ],                        
                        "ProductPrices": [
                            {
                                "ProductID": "1cd995b0-a8f1-456c-9784-ecf3a8fc2804",
                                "ProductName": "Screws Drive Cross",
                                "ProductSKU": "Screws-SKU - 002",
                                "Price": 1.1
                            }
                        ],
                        "ChildCustomers": []
                    }
                ]
            }      
          

  
### POST [POST]
+ Request (application/json)
    + Headers
    
            api-auth-accountid:704ef231-cd93-49c9-a201-26b4b5d0d35b
            api-auth-applicationkey:0342a546-e0c2-0dff-f0be-6a5e17154033
            
    + Body 
    
            {
                "Name": "DIISR - Small Business Services customer",
                "DisplayName": "Mary Jane",
                "Currency": "AUD",
                "PaymentTerm": "30 days",
                "Discount": 0,
                "TaxRule": "GST Free Exports",
                "Carrier": "DEFAULT Carrier",
                "SalesRepresentative": null,
                "Location": "Main Warehouse",
                "Comments": null,
                "AccountReceivable": "610",
                "RevenueAccount": "200",
                "PriceTier": "Tier 1",
                "TaxNumber": null,
                "AdditionalAttribute1": null,
                "AdditionalAttribute2": null,
                "AdditionalAttribute3": null,
                "AdditionalAttribute4": null,
                "AdditionalAttribute5": null,
                "AdditionalAttribute6": null,
                "AdditionalAttribute7": null,
                "AdditionalAttribute8": null,
                "AdditionalAttribute9": null,
                "AdditionalAttribute10": null,
                "AttributeSet": null,
                "Tags": null,
                "Status": "Active",
                "IsOnCreditHold": true,
                "IsLegalEntity": true,
                "CustomerParentID": "ceb4ef7a-e23d-4730-8021-e807e5b76882",
                "CustomerParentName": "Parent customer test",
                "IsBillParent":true,
                "Addresses": [
                    {
                        "ID": "4bc4e423-d8af-454d-a186-4a827c15bd0b",
                        "CustomerID": "4978c3ff-4382-4045-819b-2971480ddaf1",
                        "Line1": "L3, Southbank House",
                        "Line2": "13 Gallery Ave",
                        "City": "Melbourne",
                        "State": "VIC",
                        "Postcode": "3131",
                        "Country": "Uruguay",
                        "Type": "Business",
                        "DefaultForType": true
                    },
                    {
                        "ID": "35cec087-04da-46b5-b3c8-c3a7311f2417",
                        "CustomerID": "4978c3ff-4382-4045-819b-2971480ddaf1",
                        "Line1": "L3, Southbank House",
                        "Line2": "13 Gallery Ave",
                        "City": "Melbourne",
                        "State": "VIC",
                        "Postcode": "3131",
                        "Country": "Uruguay",
                        "Type": "Billing",
                        "DefaultForType": true
                    }
                ],
                "Contacts": [
                    {
                        "ID": "1d62f59b-657d-423f-ad95-9ad9ec4f29a3",
                        "CustomerID": "4978c3ff-4382-4045-819b-2971480ddaf1",
                        "Name": "Sheree Bond",
                        "JobTitle": null,
                        "Phone": "0800 4389376",
                        "MobilePhone": null,
                        "Fax": "03 4389379",
                        "Email": "accounts@diisr.govt",
                        "Website": null,
                        "Default": true,
                        "Comment": null,
                        "IncludeInEmail": false,
                        "MarketingConsent": 1,
                    }
                ]                
            }

+ Response 200 (application/json)
    + Body 
    
            {
                "Total": 1,
                "Page": 1,
                "CustomerList": [
                    {
                        "ID": "7d6b441a-3067-42b1-9b81-2def95df827b",
                        "Name": "DIISR - Small Business Services customer",
                        "DisplayName": "Mary Jane",
                        "Currency": "AUD",
                        "PaymentTerm": "30 days",
                        "Discount": 0,
                        "TaxRule": "GST Free Exports",
                        "Carrier": "DEFAULT Carrier",
                        "SalesRepresentative": null,
                        "Location": "Main Warehouse",
                        "Comments": null,
                        "AccountReceivable": "610",
                        "RevenueAccount": "200",
                        "PriceTier": "Tier 1",
                        "TaxNumber": null,
                        "AdditionalAttribute1": null,
                        "AdditionalAttribute2": null,
                        "AdditionalAttribute3": null,
                        "AdditionalAttribute4": null,
                        "AdditionalAttribute5": null,
                        "AdditionalAttribute6": null,
                        "AdditionalAttribute7": null,
                        "AdditionalAttribute8": null,
                        "AdditionalAttribute9": null,
                        "AdditionalAttribute10": null,
                        "AttributeSet": null,
                        "Tags": null,
                        "Status": "Active",
                        "IsOnCreditHold": true,
                        "IsLegalEntity": true,
                        "CustomerParentID": "ceb4ef7a-e23d-4730-8021-e807e5b76882",
                        "CustomerParentName": "Parent customer test",
                        "IsBillParent":true,
                        "LastModifiedOn": "2018-01-31T06:07:43.46Z",
                        "CreditLimit": 0
                        "Addresses": [
                            {
                                "ID": "b2e8260c-29f8-4153-b8bc-3b4932cb1e1d",
                                "CustomerID": "7d6b441a-3067-42b1-9b81-2def95df827b",
                                "Line1": "L3, Southbank House",
                                "Line2": "13 Gallery Ave",
                                "City": "Melbourne",
                                "State": "VIC",
                                "Postcode": "3131",
                                "Country": "Uruguay",
                                "Type": "Billing",
                                "DefaultForType": true
                            },
                            {
                                "ID": "505080d3-ebad-4d03-85ae-88df19536bc9",
                                "CustomerID": "7d6b441a-3067-42b1-9b81-2def95df827b",
                                "Line1": "L3, Southbank House",
                                "Line2": "13 Gallery Ave",
                                "City": "Melbourne",
                                "State": "VIC",
                                "Postcode": "3131",
                                "Country": "Uruguay",
                                "Type": "Business",
                                "DefaultForType": true
                            }
                        ],
                        "Contacts": [
                            {
                                "ID": "817e0314-97fc-4d3f-855b-14fbb89de2ba",
                                "CustomerID": "7d6b441a-3067-42b1-9b81-2def95df827b",
                                "Name": "Sheree Bond",
                                "JobTitle": null,
                                "Phone": "0800 4389376",
                                "MobilePhone": null,
                                "Fax": "03 4389379",
                                "Email": "accounts@diisr.govt",
                                "Website": null,
                                "Default": true,
                                "Comment": null,
                                "IncludeInEmail": false,
                                "MarketingConsent": 1,
                            }
                        ],
                        "ChildCustomers": []
                    }
                ]
            }  
  

### PUT [PUT]
+ Request (application/json)
    + Headers
    
            api-auth-accountid:704ef231-cd93-49c9-a201-26b4b5d0d35b
            api-auth-applicationkey:0342a546-e0c2-0dff-f0be-6a5e17154033
            
    + Body 
   
            {
                "ID": "7d6b441a-3067-42b1-9b81-2def95df827b",
                "Name": "DIISR - Small Business Services customer",
                "DisplayName": "Mary Jane",
                "Currency": "AUD",
                "PaymentTerm": "30 days",
                "Discount": 0,
                "TaxRule": "GST Free Exports",
                "Carrier": "DEFAULT Carrier",
                "SalesRepresentative": null,
                "Location": "Main Warehouse",
                "Comments": null,
                "AccountReceivable": "610",
                "RevenueAccount": "200",
                "PriceTier": "Tier 1",
                "TaxNumber": null,
                "AdditionalAttribute1": null,
                "AdditionalAttribute2": null,
                "AdditionalAttribute3": null,
                "AdditionalAttribute4": null,
                "AdditionalAttribute5": null,
                "AdditionalAttribute6": null,
                "AdditionalAttribute7": null,
                "AdditionalAttribute8": null,
                "AdditionalAttribute9": null,
                "AdditionalAttribute10": null,
                "AttributeSet": null,
                "Tags": null,
                "IsOnCreditHold": false,
                "IsLegalEntity": false,
                "CustomerParentID": null,
                "CustomerParentName": null,
                "IsBillParent":false,
                "Status": "Active",
                "Addresses": [
                    {
                        "ID": "4bc4e423-d8af-454d-a186-4a827c15bd0b",
                        "CustomerID": "4978c3ff-4382-4045-819b-2971480ddaf1",
                        "Line1": "L3, Southbank House",
                        "Line2": "13 Gallery Ave",
                        "City": "Melbourne",
                        "State": "VIC",
                        "Postcode": "3131",
                        "Country": "Uruguay",
                        "Type": "Business",
                        "DefaultForType": true
                    },
                    {
                        "ID": "35cec087-04da-46b5-b3c8-c3a7311f2417",
                        "CustomerID": "4978c3ff-4382-4045-819b-2971480ddaf1",
                        "Line1": "L3, Southbank House",
                        "Line2": "13 Gallery Ave",
                        "City": "Melbourne",
                        "State": "VIC",
                        "Postcode": "3131",
                        "Country": "Uruguay",
                        "Type": "Billing",
                        "DefaultForType": true
                    }
                ],
                "Contacts": [
                    {
                        "ID": "1d62f59b-657d-423f-ad95-9ad9ec4f29a3",
                        "CustomerID": "4978c3ff-4382-4045-819b-2971480ddaf1",
                        "Name": "Sheree Bond",
                        "JobTitle": null,
                        "Phone": "0800 4389376",
                        "MobilePhone": null,
                        "Fax": "03 4389379",
                        "Email": "accounts@diisr.govt",
                        "Website": null,
                        "Default": true,
                        "Comment": null,
                        "IncludeInEmail": false,
                        "MarketingConsent": 3,
                    }
                ]
            }
        

+ Response 200 (application/json)
    + Body 
    
            {
                "Total": 1,
                "Page": 1,
                "CustomerList": [
                    {
                        "ID": "7d6b441a-3067-42b1-9b81-2def95df827b",
                        "Name": "DIISR - Small Business Services customer",
                        "DisplayName": "Mary Jane",
                        "Currency": "AUD",
                        "PaymentTerm": "30 days",
                        "Discount": 0,
                        "TaxRule": "GST Free Exports",
                        "Carrier": "DEFAULT Carrier",
                        "SalesRepresentative": null,
                        "Location": "Main Warehouse",
                        "Comments": "",
                        "AccountReceivable": "610",
                        "RevenueAccount": "200",
                        "PriceTier": "Tier 1",
                        "TaxNumber": "",
                        "AdditionalAttribute1": "",
                        "AdditionalAttribute2": "",
                        "AdditionalAttribute3": "",
                        "AdditionalAttribute4": "",
                        "AdditionalAttribute5": "",
                        "AdditionalAttribute6": "",
                        "AdditionalAttribute7": "",
                        "AdditionalAttribute8": "",
                        "AdditionalAttribute9": "",
                        "AdditionalAttribute10": "",
                        "AttributeSet": null,
                        "Tags": "",
                        "Status": "Active",
                        "IsOnCreditHold": false,
                        "IsLegalEntity": false,
                        "CustomerParentID": null,
                        "CustomerParentName": null,
                        "IsBillParent":false,
                        "LastModifiedOn": "2018-01-31T06:20:43.46Z",
                        "CreditLimit": 0
                        "Addresses": [
                            {
                                "ID": "35cec087-04da-46b5-b3c8-c3a7311f2417",
                                "CustomerID": "7d6b441a-3067-42b1-9b81-2def95df827b",
                                "Line1": "L3, Southbank House",
                                "Line2": "13 Gallery Ave",
                                "City": "Melbourne",
                                "State": "VIC",
                                "Postcode": "3131",
                                "Country": "Uruguay",
                                "Type": "Billing",
                                "DefaultForType": true
                            },
                            {
                                "ID": "4bc4e423-d8af-454d-a186-4a827c15bd0b",
                                "CustomerID": "7d6b441a-3067-42b1-9b81-2def95df827b",
                                "Line1": "L3, Southbank House",
                                "Line2": "13 Gallery Ave",
                                "City": "Melbourne",
                                "State": "VIC",
                                "Postcode": "3131",
                                "Country": "Uruguay",
                                "Type": "Business",
                                "DefaultForType": true
                            }
                        ],
                        "Contacts": [
                            {
                                "ID": "1d62f59b-657d-423f-ad95-9ad9ec4f29a3",
                                "CustomerID": "7d6b441a-3067-42b1-9b81-2def95df827b",
                                "Name": "Sheree Bond",
                                "JobTitle": null,
                                "Phone": "0800 4389376",
                                "MobilePhone": null,
                                "Fax": "03 4389379",
                                "Email": "accounts@diisr.govt",
                                "Website": null,
                                "Default": true,
                                "Comment": null,
                                "IncludeInEmail": false,
                                "MarketingConsent": 3,
                            }
                        ],
                        "ChildCustomers": [
                            {
                                "CustomerID": "4f36c2a6-f736-450f-be41-28372bde80f6",
                                "CustomerName": "Child Customer"
                            }
                        ]
                    }
                ]
            }

## Customer Default Template [/ref/customer/templates]
### Available fields for Customer Default Template
| Property | Type           | Length | Required |Notes       |
|:-------|----------------------|---------|----------|----------|
| `CustomerID`  | Guid           |         |   Yes*  |  Customer ID. |
| `TemplateID`  | Guid           |         |   Yes*  | Template ID.  |

Customer Default Template CRUD Operations.

### GET [GET /ref/customer/templates?Page={Page}&Limit={Limit}&CustomerId={CustomerId}]
+ Parameters
    + Page (optional, number) ... Page
        + Default: 1
    + Limit (optional, number) ... Specifies the page size for pagination. Default page size is 100.
        + Default: 100
    + CustomerId (optional, Guid) ... Only return Customer Default Templates for specified CustomerId.
        + Default: null
        
+ Request (application/json)
    + Headers
    
            api-auth-accountid:704ef231-cd93-49c9-a201-26b4b5d0d35b
            api-auth-applicationkey:0342a546-e0c2-0dff-f0be-6a5e17154033
        
+ Response 200 (application/json)
    + Body
    
            {
              "Page": 1,
              "CustomerTemplates": [
                {
                  "CustomerID": "ce607b9a-dc9b-4ef4-9ed3-495434e90467",
                  "TemplateID": "5bafe3f7-738c-459d-9a01-6337f15decbb"
                },
                {
                  "CustomerID": "ce607b9a-dc9b-4ef4-9ed3-495434e90467",
                  "TemplateID": "0a3c1651-9ab3-495d-9d87-2cb7fa2d0f7d"
                },
                {
                  "CustomerID": "047d59f1-19dd-4bd9-9f75-5bff1431d100",
                  "TemplateID": "344eaab7-c7f5-4b1e-a7b6-d29ebf6cf7b6"
                }
              ]
            }    

### POST [POST]

+ Request (application/json)
    + Headers
    
            api-auth-accountid:704ef231-cd93-49c9-a201-26b4b5d0d35b
            api-auth-applicationkey:0342a546-e0c2-0dff-f0be-6a5e17154033
            
    + Body
        
            {
              "CustomerTemplates": [
                {
                  "CustomerID": "d7392f64-4d48-424c-8dfa-36f8895162ff",
                  "TemplateID": "344eaab7-c7f5-4b1e-a7b6-d29ebf6cf7b6"
                },
                {
                  "CustomerID": "d7392f64-4d48-424c-8dfa-36f8895162ff",
                  "TemplateID": "0a3c1651-9ab3-495d-9d87-2cb7fa2d0f7d"
                }
              ]
            }
        
+ Response 200 (application/json)
    + Body
    
            {
              "Page": 1,
              "CustomerTemplates": [
                {
                  "CustomerID": "d7392f64-4d48-424c-8dfa-36f8895162ff",
                  "TemplateID": "344eaab7-c7f5-4b1e-a7b6-d29ebf6cf7b6"
                },
                {
                  "CustomerID": "d7392f64-4d48-424c-8dfa-36f8895162ff",
                  "TemplateID": "0a3c1651-9ab3-495d-9d87-2cb7fa2d0f7d"
                },
                {
                  "CustomerID": "047d59f1-19dd-4bd9-9f75-5bff1431d100",
                  "TemplateID": "344eaab7-c7f5-4b1e-a7b6-d29ebf6cf7b6"
                }
              ]
            }

### DELETE [DELETE /ref/customer/templates?TemplateId={TemplateId}&CustomerId={CustomerId}]

+ Parameters
    + TemplateId (required, string) ... Provide Template ID.
    + CustomerId (required, string) ... Provide Customer ID.
    

+ Request (application/json)
    + Headers
    
            api-auth-accountid:704ef231-cd93-49c9-a201-26b4b5d0d35b
            api-auth-applicationkey:0342a546-e0c2-0dff-f0be-6a5e17154033

+ Response 200 (application/json)
    + Body
    
            {
              "Page": 1,
              "CustomerTemplates": [
                {
                  "CustomerID": "047d59f1-19dd-4bd9-9f75-5bff1431d100",
                  "TemplateID": "344eaab7-c7f5-4b1e-a7b6-d29ebf6cf7b6"
                }
              ]
            }

## Customer Credits [/ref/customer/credits]
### Available fields for Customer Credits
| Property | Type           | Length | Required |Notes       |
|:-------|----------------------|---------|----------|----------|
| `CreditID`  | Guid           |         |     |  Credit ID, identifier unique key.  |
| `CustomerID`  | Guid           |         |     |  Customer ID|
| `CustomerName`  | String           |         |    | Customer name.  |
| `Account`  | String           |         |    | Credit account.  |
| `Amount`  | Decimal           |         |     | Credit amount.  |
| `RemainingAmount`  | Decimal           |         |    |Credit remaining amount.  |
| `Currency`  | String           |         |    | Credit currency name.  |
| `ConvRate`  | Decimal           |         |    | Currency conversion rate.  |
| `Date`  | Date           |         |    | Date paid |
| `Description`  | String           |         |    | Credit description |



### GET [GET /ref/customer/credits?Page={Page}&Limit={Limit}&CustomerID={CustomerID}&ShowUsedCredits={ShowUsedCredits}]
+ Parameters
    + Page (optional, number) ... Page
        + Default: 1
    + Limit (optional, number) ... Specifies the page size for pagination. Default page size is 100.
        + Default: 100
    + CustomerID (optional, Guid) ... Only return Customer Credits for specified CustomerID.
        + Default: null
    + ShowUsedCredits (optional, Boolean) ... Return Customer Credits icluded already used.
        + Default: false
        
+ Request (application/json)
    + Headers
    
            api-auth-accountid:704ef231-cd93-49c9-a201-26b4b5d0d35b
            api-auth-applicationkey:0342a546-e0c2-0dff-f0be-6a5e17154033
        
+ Response 200 (application/json)
    + Body
    
            {
              "Page": 1,
              "CustomerCredits": [
                {
                  "CreditID": "55607b9a-dc9b-4ef4-9ed3-495434e90434",
                  "CustomerID": "ce607b9a-dc9b-4ef4-9ed3-495434e90467",
                  "CustomerName": "Customer name",
                  "Account": "1200",
                  "Amount": 100,
                  "RemainingAmount": 50,
                  "Currency": "USD",
                  "ConvRate": 1,
                  "Date": "2024-01-09T00:00:00",
                  "Description": "Credit by prepayments"
                },
                {
                  "CreditID": "67607b9a-dc9b-4ef4-9ed3-495434e90489",
                  "CustomerID": "ce607b9a-dc9b-4ef4-9ed3-495434e90467",
                  "CustomerName": "Customer name",
                  "Account": "1300",
                  "Amount": 100,
                  "RemainingAmount": 0,
                  "Currency": "USD",
                  "ConvRate": 1,
                  "Date": "2024-04-09T00:00:00",
                  "Description": "Credit by prepayments"
                }
              ]
            }    
            


# Group Disassembly

## Disassembly List [/disassemblyList]
### Available fields for Disassembly List
| Property | Type           | Length | Required |Notes       |
|:-------|----------------------|---------|----------|----------|
| `TaskID`  | Guid           |         |          |  Unique ID.        |
| `DisassemblyNumber`  | String           |         |          |Disassembly Number        |
| `ProductID`  | Guid           |         |          |Product ID        |
| `ProductCode`  | String           |         |          |Product Code        |
| `ProductName`  | String           |         |          |Product Name         |
| `Quantity`  | Decimal           |         |          |Quantity          |
| `LocationID`  | Guid           |         |          |Location ID    |
| `Location`  | String           |         |          |Location Name     |
| `Date`  | DateTime           |         |          |Date         |
| `Status`  | String           |         |          |Disassembly Task Status. Available values are `DRAFT`,`WORK IN PROGRESS`,`COMPLETED`,`VOIDED`         |

### GET [GET /disassemblyList?Page={Page}&Limit={Limit}&Status={Status}&Search={Search}]

+ Parameters
    + Page (optional, number) ... Page (Default: 1)
    + Limit (optional, number) ... Specifies the page size for pagination. Default page size is 100. (Default: 100)
    + Status (optional) ... Only return Disassembly with specified status (Default: null)
    + Search (optional) ... Only return Disassembly with search value contained in one of these fields: DisassemblyNumber, Location, Status, Name, ProductCode (Default: null)

+ Request (application/json)
    + Headers
    
            api-auth-accountid:704ef231-cd93-49c9-a201-26b4b5d0d35b
            api-auth-applicationkey:0342a546-e0c2-0dff-f0be-6a5e17154033

+ Response 200 (application/json)
    + Body
    
            {
                "Total": 9,
                "Page": 1,
                "Disassemblies": [
                    {
                        "TaskID": "122df91c-1ce5-46e2-86f7-52cc14e7964b",
                        "DisassemblyNumber": "FG-00018",
                        "ProductID": "524c20a3-a8ec-44f2-9685-311f1f7d1498",
                        "ProductCode": "Bread",
                        "ProductName": "Baked Bread",
                        "Quantity": 1,
                        "LocationID": "19aeca31-bd49-4fbe-8abd-37a6169cc2cb",
                        "Location": "Main Warehouse",
                        "Date": "2018-01-09T00:00:00",
                        "Status": "DRAFT"
                    }
                ]
            }
            

## Disassembly [/disassembly]
### Available fields for Disassembly
| Property | Type           | Length | Required |Notes       |
|:-------|----------------------|---------|----------|----------|
| `TaskID`  | Guid           |         |          |  Unique ID.        |
| `DisassemblyNumber`  | String           |         |          |Disassembly Number        |
| `Status`  | String           |         |          |Disassembly Task Status. Available values are `DRAFT`,`WORK IN PROGRESS`,`COMPLETED`,`VOIDED`         |
| `ProductID`  | Guid           |         |          |Product ID        |
| `ProductCode`  | String           |         |          |Product Code        |
| `ProductName`  | String           |         |          |Product Name         |
| `LocationID`  | Guid           |         |          |Location ID    |
| `Location`  | String           |         |          |Location Name     |
| `WIPAccount`  | String           |         |          |Work in Progress Account          |
| `Quantity`  | Decimal           |         |          |Quantity          |
| `AssemblyInstructionURL`  | String           |         |          |Assembly Instruction URL     |
| `PickLines`  |<a href="#DisassemblyPickLineModel"><b>[] Disassembly Pick Line Model</b></a>|         |          |        |
| `OrderLines`  |<a href="#DisassemblyOrderLineModel"><b>[] Disassembly Order Line Model</b></a>|         |          |        |
| `OrderServiceLines`  |<a href="#DisassemblyOrderServiceLineModel"><b>[] Disassembly Order Service Line Model</b></a>|         |          |        |
| `Transactions`  |<a href="#TransactionStockLineModel"><b>[] Transaction Stock Line Model</b></a>|         |          |        |
| `Errors`  |<a href="#ErrorModel"><b>[] Error Model</b></a>|         |          |If While processing `POST` method, some errors occurred, but task was created, this property will contain array of error messages.    |

### Available fields for POST method
| Property | Type           | Length | Required |Notes       |
|:-------|----------------------|---------|----------|----------|
| `Status`  | String           |         |     Yes     |Disassembly Task Status. Available values are `DRAFT`,`AUTHORISED`,`IN PROGRESS`,`COMPLETED`.|
| `ProductID`  | Guid           |         |Yes*|Product ID. Required if `ProductCode` is empty       |
| `ProductCode`  | String           |         |Yes*|Product Code. Required if `ProductID` is empty |
| `LocationID`  | Guid           |         | Yes*         |Location ID. Required if `Location` is empty    |
| `Location`  | Decimal           |         | Yes*         |Location Name. Required if `LocationID` is empty     |
| `WIPAccount`  | String           |         |    Yes      |Work in Progress Account          |
| `Quantity`  | Decimal           |         |    Yes      |Quantity          |

### POST method Statuses meanings
| Status |Action |
|:-------|----------|
|`WORK IN PROGRESS`|New Disassembly task will be created, system will try to automatically add pick items.|
|`COMPLETED`|New Disassembly task will be created, system will try to automatically add pick items, order items, and Complete the task.|


### GET [GET /disassembly?TaskID={TaskID}]
+ Parameters
    + TaskID (optional) ... Returns detailed info of a particular Disassembly

+ Request (application/json)
    + Headers
    
            api-auth-accountid:704ef231-cd93-49c9-a201-26b4b5d0d35b
            api-auth-applicationkey:0342a546-e0c2-0dff-f0be-6a5e17154033

+ Response 200 (application/json)
    + Body
    
            {
                "TaskID": "38cddb52-9a81-4c07-9791-362936efa552",
                "DisassemblyNumber": "FG-00026",
                "Status": "COMPLETED",
                "ProductID": "524c20a3-a8ec-44f2-9685-311f1f7d1498",
                "ProductCode": "Bread",
                "ProductName": "Baked Bread",
                "LocationID": "19aeca31-bd49-4fbe-8abd-37a6169cc2cb",
                "Location": "Main Warehouse",
                "CompletionDate": "2017-12-21T00:00:00",
                "WIPAccount": "715",
                "Quantity": 1,
                "AssemblyInstructionURL": "",
                "PickLines": [
                    {
                        "BinID": null,
                        "Bin": null,
                        "Date": "2017-12-27T00:00:00",
                        "BatchSN": "3",
                        "ExpiryDate": "2017-12-21T00:00:00",
                        "Available": 48,
                        "UnitCost": 5,
                        "Quantity": 1,
                        "TotalCost": 5
                    }
                ],
                "OrderLines": [
                    {
                        "ProductID": "8879b7f5-3aa7-4c7c-ba2c-d0bcc48ba7c3",
                        "ProductCode": "GB3-White",
                        "Name": "Golf balls white 3-pack",
                        "BinID": null,
                        "Bin": null,
                        "Unit": "Item",
                        "BatchSN": null,
                        "ExpiryDate": null,
                        "Account": "715",
                        "Quantity": 1,
                        "Cost": 5
                    }
                ],
                "OrderServiceLines": [
                    {
                        "ProductID": "5c6a9204-275f-4a8b-8a90-317d674a4504",
                        "Name": "Half day training - Microsoft Office",
                        "Account": "416",
                        "Comments": "",
                        "Amount": 600
                    }
                ],
                "Transactions": [
                    {
                        "ID": "80b705e7-00af-4260-9dd2-22240e31ff89",
                        "EffectiveDate": "2018-01-12T00:00:00",
                        "Debit": "715",
                        "Credit": "416",
                        "Amount": 600
                    }
                ],
                "Errors": []
            }
    

### POST [POST]
+ Request (application/json)
    + Headers
    
            api-auth-accountid:704ef231-cd93-49c9-a201-26b4b5d0d35b
            api-auth-applicationkey:0342a546-e0c2-0dff-f0be-6a5e17154033
    + Body 
    
            {
                "Status": "COMPLETED",
                "ProductID": "524c20a3-a8ec-44f2-9685-311f1f7d1498",
                "ProductCode": "Bread",
                "ProductName": "Baked Bread",
                "LocationID": "19aeca31-bd49-4fbe-8abd-37a6169cc2cb",
                "Location": "Main Warehouse",
                "CompletionDate": "2017-12-21T00:00:00",
                "WIPAccount": "715",
                "Quantity": 1
            }
+ Response 200 (application/json)
    + Body 
            
            {
                "TaskID": "eb366295-5342-40e6-b1bf-9e44fbc1487d",
                "DisassemblyNumber": "FG-00027",
                "Status": "COMPLETED",
                "ProductID": "524c20a3-a8ec-44f2-9685-311f1f7d1498",
                "ProductCode": "Bread",
                "ProductName": "Baked Bread",
                "LocationID": "19aeca31-bd49-4fbe-8abd-37a6169cc2cb",
                "Location": "Main Warehouse",
                "CompletionDate": "2017-12-21T00:00:00",
                "WIPAccount": "715",
                "Quantity": 1,
                "AssemblyInstructionURL": "",
                "PickLines": [
                    {
                        "BinID": null,
                        "Bin": null,
                        "Date": "2017-12-27T00:00:00",
                        "BatchSN": "3",
                        "ExpiryDate": "2017-12-21T00:00:00",
                        "Available": 49,
                        "UnitCost": 5,
                        "Quantity": 1,
                        "TotalCost": 5
                    }
                ],
                "OrderLines": [
                    {
                        "ProductID": "8879b7f5-3aa7-4c7c-ba2c-d0bcc48ba7c3",
                        "ProductCode": "GB3-White",
                        "Name": "Golf balls white 3-pack",
                        "BinID": null,
                        "Bin": null,
                        "Unit": "Item",
                        "BatchSN": null,
                        "ExpiryDate": null,
                        "Account": "715",
                        "Quantity": 1,
                        "Cost": 5
                    }
                ],
                "OrderServiceLines": [
                    {
                        "ProductID": "5c6a9204-275f-4a8b-8a90-317d674a4504",
                        "Name": "Half day training - Microsoft Office",
                        "Account": "416",
                        "Comments": "",
                        "Amount": 600
                    }
                ],
                "Transactions": [
                    {
                        "ID": "81140682-6504-4799-b54e-368d8fae2253",
                        "EffectiveDate": "2018-01-12T00:00:00",
                        "Debit": "715",
                        "Credit": "416",
                        "Amount": 600
                    }
                ],
                "Errors": []
            }
                

### Delete [DELETE /disassembly?ID={ID}&Void={Void}]
        
+ Parameters
    + ID (required) ... ID of Disassembly to Void or Undo
    + Void (optional,boolean) ... Void or Undo Disassembly
        + Default: false
        
+ Request (application/json)
    + Headers
    
            api-auth-accountid:704ef231-cd93-49c9-a201-26b4b5d0d35b
            api-auth-applicationkey:0342a546-e0c2-0dff-f0be-6a5e17154033

+ Response 200 (application/json)
    + Body
    
            {
                "TaskID": "eb366295-5342-40e6-b1bf-9e44fbc1487d",
                "DisassemblyNumber": "FG-00027",
                "Status": "VOIDED",
                "ProductID": "524c20a3-a8ec-44f2-9685-311f1f7d1498",
                "ProductCode": "Bread",
                "ProductName": "Baked Bread",
                "LocationID": "19aeca31-bd49-4fbe-8abd-37a6169cc2cb",
                "Location": "Main Warehouse",
                "CompletionDate": "2017-12-21T00:00:00",
                "WIPAccount": "715",
                "Quantity": 1,
                "AssemblyInstructionURL": "",
                "PickLines": [],
                "OrderLines": [],
                "OrderServiceLines": [],
                "Transactions": [],
                "Errors": []
            }
    

## Disassembly Order [/disassembly/order]

### Available fields for Disassembly Order
| Property | Type           | Length | Required |Notes       |
|:-------|----------------------|---------|----------|----------|
| `TaskID`  | Guid           |         |          |  Unique ID.        |
| `Status`  | String           |         |          |Disassembly Task Status. Available values are `DRAFT`,`WORK IN PROGRESS`,`COMPLETED`,`VOIDED`. Available values for `POST` are `WORK IN PROGRESS` and `COMPLETED`.|
| `OrderLines`  |<a href="#DisassemblyOrderLineModel"><b>[] Disassembly Order Line Model</b></a>|         |        |

### GET [GET /disassembly/order?TaskID={TaskID}]
+ Parameters
    + TaskID (optional) ... Returns Order info of a particular Disassembly

+ Request (application/json)
    + Headers
    
            api-auth-accountid:704ef231-cd93-49c9-a201-26b4b5d0d35b
            api-auth-applicationkey:0342a546-e0c2-0dff-f0be-6a5e17154033

+ Response 200 (application/json)
    + Body
    
            {
                "TaskID": "122df91c-1ce5-46e2-86f7-52cc14e7964b",
                "Status": "COMPLETED",
                "CompletionDate": "2017-12-21T00:00:00",
                "OrderLines": [
                    {
                        "ProductID": "8879b7f5-3aa7-4c7c-ba2c-d0bcc48ba7c3",
                        "ProductCode": "GB3-White",
                        "Name": "Golf balls white 3-pack",
                        "BinID": null,
                        "Bin": null,
                        "Unit": "Item",
                        "BatchSN": null,
                        "ExpiryDate": null,
                        "Account": "715",
                        "Quantity": 1,
                        "Cost": 5
                    }
                ],
                "OrderServiceLines": [
                    {
                        "ProductID": "5c6a9204-275f-4a8b-8a90-317d674a4504",
                        "Name": "Half day training - Microsoft Office",
                        "Account": "416",
                        "Comments": "",
                        "Amount": 600
                    }
                ]
            }
            

### POST [POST]
+ Request (application/json)
    + Headers
    
            api-auth-accountid:704ef231-cd93-49c9-a201-26b4b5d0d35b
            api-auth-applicationkey:0342a546-e0c2-0dff-f0be-6a5e17154033
    + Body 
    
            {
                "TaskID": "122df91c-1ce5-46e2-86f7-52cc14e7964b",
                "Status": "COMPLETED",
                "CompletionDate": "2017-12-21T00:00:00",
                "OrderLines": [
                    {
                        "ProductID": "8879b7f5-3aa7-4c7c-ba2c-d0bcc48ba7c3",
                        "ProductCode": "GB3-White",
                        "Name": "Golf balls white 3-pack",
                        "BinID": null,
                        "Bin": null,
                        "Unit": "Item",
                        "BatchSN": null,
                        "ExpiryDate": null,
                        "Account": "715",
                        "Quantity": 1,
                        "Cost": 5
                    }
                ],
                "OrderServiceLines": [
                    {
                        "ProductID": "5c6a9204-275f-4a8b-8a90-317d674a4504",
                        "Name": "Half day training - Microsoft Office",
                        "Account": "416",
                        "Comments": "Test",
                        "Amount": 600
                    }
                ]
            }
+ Response 200 (application/json)
    + Body 
    
            {
                "TaskID": "122df91c-1ce5-46e2-86f7-52cc14e7964b",
                "Status": "COMPLETED",
                "CompletionDate": "2017-12-21T00:00:00",
                "OrderLines": [
                    {
                        "ProductID": "8879b7f5-3aa7-4c7c-ba2c-d0bcc48ba7c3",
                        "ProductCode": "GB3-White",
                        "Name": "Golf balls white 3-pack",
                        "BinID": null,
                        "Bin": null,
                        "Unit": "Item",
                        "BatchSN": null,
                        "ExpiryDate": null,
                        "Account": "715",
                        "Quantity": 1,
                        "Cost": 5
                    }
                ],
                "OrderServiceLines": [
                    {
                        "ProductID": "5c6a9204-275f-4a8b-8a90-317d674a4504",
                        "Name": "Half day training - Microsoft Office",
                        "Account": "416",
                        "Comments": "Test",
                        "Amount": 600
                    }
                ]
            } 


# Group Finished Goods

## Finished Goods List [/finishedGoodsList]

### Available fields for Finished Goods List
| Property | Type           | Length | Required |Notes       |
|:-------|----------------------|---------|----------|----------|
| `TaskID`  | Guid           |         |          |  Unique ID.        |
| `AssemblyNumber`  | String           |         |          |Assembly Number        |
| `BatchSN`  | String           |         |          |Batch serial number       |
| `ExpiryDate`  | DateTime           |         |          |Batch Expiry Date          |
| `ProductID`  | Guid           |         |          |Product ID        |
| `ProductCode`  | String           |         |          |Product Code        |
| `ProductName`  | String           |         |          |Product Name         |
| `Quantity`  | Decimal           |         |          |Quantity          |
| `LocationID`  | Guid           |         |          |Location ID    |
| `Location`  | String           |         |          |Location Name     |
| `Date`  | DateTime           |         |          |Date         |
| `Status`  | String           |         |          |Finished Goods Task Status. Available values are `DRAFT`,`AUTHORISED`,`IN PROGRESS`,`COMPLETED`,`VOIDED`         |
| `UnitCost`  | Decimal           |         |          |Unit Cost         |
| `Notes`  | String           |         |          |Notes        |
|`CustomField1`|String|||Value of Finished Goods additional attribute 1 <br> Date format: Use `yyyy-mm-dd` <br> Numeric format: Enter a number with max 4 decimal palces|
|`CustomField2`|String|||Value of Finished Goods additional attribute 2 <br> Date format: Use `yyyy-mm-dd` <br> Numeric format: Enter a number with max 4 decimal palces|
|`CustomField3`|String|||Value of Finished Goods additional attribute 3 <br> Date format: Use `yyyy-mm-dd` <br> Numeric format: Enter a number with max 4 decimal palces|
|`CustomField4`|String|||Value of Finished Goods additional attribute 4 <br> Date format: Use `yyyy-mm-dd` <br> Numeric format: Enter a number with max 4 decimal palces|
|`CustomField5`|String|||Value of Finished Goods additional attribute 5 <br> Date format: Use `yyyy-mm-dd` <br> Numeric format: Enter a number with max 4 decimal palces|
|`CustomField6`|String|||Value of Finished Goods additional attribute 6 <br> Date format: Use `yyyy-mm-dd` <br> Numeric format: Enter a number with max 4 decimal palces|
|`CustomField7`|String|||Value of Finished Goods additional attribute 7 <br> Date format: Use `yyyy-mm-dd` <br> Numeric format: Enter a number with max 4 decimal palces|
|`CustomField8`|String|||Value of Finished Goods additional attribute 8 <br> Date format: Use `yyyy-mm-dd` <br> Numeric format: Enter a number with max 4 decimal palces|
|`CustomField9`|String|||Value of Finished Goods additional attribute 9 <br> Date format: Use `yyyy-mm-dd` <br> Numeric format: Enter a number with max 4 decimal palces|
|`CustomField10`|String|||Value of Finished Goods additional attribute 10 <br> Date format: Use `yyyy-mm-dd` <br> Numeric format: Enter a number with max 4 decimal palces|

### GET [GET /finishedGoodsList?Page={Page}&Limit={Limit}&Status={Status}&Search={Search}&SaleID={SaleID}]

+ Parameters
    + Page (optional, number) ... Page (Default: 1)
    + Limit (optional, number) ... Specifies the page size for pagination. Default page size is 100. (Default: 100)
    + Status (optional) ... Only return Finished Goods with specified status (Default: null)
    + Search (optional) ... Only return Finished Goods with search value contained in one of these fields: AssemblyNumber, Location, Status, Name, ProductCode, BatchSN, Notes (Default: null)
    + SaleID (optional) ... Only return Finished Goods related to particular Sale

+ Request (application/json)
    + Headers
    
            api-auth-accountid:704ef231-cd93-49c9-a201-26b4b5d0d35b
            api-auth-applicationkey:0342a546-e0c2-0dff-f0be-6a5e17154033

+ Response 200 (application/json)
    + Body
    
            {
                "Total": 14,
                "Page": 1,
                "FinishedGoods": [
                    {
                        "TaskID": "c1819dba-772c-4689-8032-0ee7acb4bd66",
                        "AssemblyNumber": "FG-00001",
                        "BatchSN": "FG-00001",
                        "ExpiryDate": "2018-01-11T00:00:00",
                        "ProductID": "524c20a3-a8ec-44f2-9685-311f1f7d1498",
                        "ProductCode": "Bread",
                        "ProductName": "Baked Bread",
                        "Quantity": 1,
                        "LocationID": "19aeca31-bd49-4fbe-8abd-37a6169cc2cb",
                        "Location": "Main Warehouse",
                        "Date": "2018-01-03T00:00:00",
                        "Status": "COMPLETED",
                        "UnitCost": 0,
                        "Notes": "",
                        "CustomField1": "Low",
                        "CustomField2": "false",
                        "CustomField3": "test",
                        "CustomField4": "",
                        "CustomField5": "",
                        "CustomField6": "",
                        "CustomField7": "",
                        "CustomField8": "",
                        "CustomField9": "",
                        "CustomField10": ""
                    }
                ]
            }


## Finished Goods [/finishedGoods]

### Available fields for Finished Goods
| Property | Type           | Length | Required |Notes       |
|:-------|----------------------|---------|----------|----------|
| `TaskID`  | Guid           |         |          |  Unique ID.        |
| `AssemblyNumber`  | String           |         |          |Assembly Number        |
| `Status`  | String           |         |          |Finished Goods Task Status. Available values are `DRAFT`,`AUTHORISED`,`IN PROGRESS`,`COMPLETED`,`VOIDED`         |
| `ProductID`  | Guid           |         |          |Product ID        |
[...]
